SystemOrganization addCategory: #ConfigurationOfXMLParser!

Object subclass: #ConfigurationOfXMLParser
	instanceVariableNames: 'project'
	classVariableNames: 'LastVersionLoad'
	poolDictionaries: ''
	category: 'ConfigurationOfXMLParser'!

!ConfigurationOfXMLParser commentStamp: '<historical>' prior: 0!
(ConfigurationOfXMLParser project version: #stable) load: 'Tests'

(ConfigurationOfXMLParser project version: '1.3') load
!

!ConfigurationOfXMLParser class methodsFor: 'private' stamp: 'DaleHenrichs 2/7/2010 09:39'!
bootstrapPackage: aString from: aPath 
	| repository version |
	repository := MCHttpRepository
				location: aPath
				user: ''
				password: ''.
	repository
		versionReaderForFileNamed: aString , '.mcz'
		do: [:reader | 
			version := reader version.
			version load.
			version workingCopy repositoryGroup addRepository: repository]! !

!ConfigurationOfXMLParser class methodsFor: 'catalog' stamp: 'StephaneDucasse 11/24/2013 18:42'!
catalogChangeLog

^ '
- next action is to remov deprecated methods

[[[ 
expiry := 1 year.
(SystemNavigation default allClassesInPackageNamed: ''XML-Parser'')
	do: [:class |
	class selectors do: [:selector | | compiledMethod timeStamp |
	compiledMethod := class compiledMethodAt: selector.
	timeStamp := compiledMethod timeStamp copyAfter: Character space.
	(compiledMethod isDeprecated
		and: [(DateAndTime now - (DateAndTime fromString: timeStamp)) > expiry])
			ifTrue: [class removeSelector: selector]]].
]]]

and may be separate the HTMLParser into its own package.



- Version 1.3 - 2013-11-22 Monty''s Enhancements
These updates add validation against internal and external DTDs, proper replacement of general and parameter entites, customizable resolution of external parsed entities using Zinc and FileSystem, awareness of notations and unparsed entities, preservation of the internal DTD subset by the DOM parser (so printing a parsed doc with a DTD will produce approximately what was input), line numbers reporting in error messages, and better well-formed and validity constraints.

I had to largely rewrite the tokenizer to make everything work, but I followed the spec closely, and it is about the same speed as long as there is no DTD to validate against.

[[[ 
	(ConfigurationOfXMLParser project version: ''1.3'') load
]]]


- Version 1.2- 2013-04-30 Removing dependency on XMLWriter.

[[[ 
	(ConfigurationOfXMLParser project version: ''1.2'') load
]]]


'! !

!ConfigurationOfXMLParser class methodsFor: 'catalog' stamp: 'StephaneDucasse 11/24/2013 18:37'!
catalogDescription

	^ 'XMLParser allows you to parse and validate well-formed XML documents. The package contains a SAX Driver and a XMLDOMParser. If you are interested by XML parsing we also suggest to have a look at the XMLPullParser package.'
! !

!ConfigurationOfXMLParser class methodsFor: 'catalog' stamp: 'StephaneDucasse 11/24/2013 18:50'!
catalogKeyClassesAndExample

^ 'The main entry point is the class ==XMLParser==. There is also the =XMLParserTest== which is a good starting point.

- For validation have a look at ==DTDDocumentValidator==.

- You can get a ==SAXDriver== for streaming nodes or ==XMLDOMParser== for getting the complete tree in memory.

This package is large so have a look. There is also an ==HTMLParser==.
'! !

!ConfigurationOfXMLParser class methodsFor: 'catalog' stamp: 'StephaneDucasse 11/24/2013 18:49'!
catalogKeywords

	^ #( XML parser validation DOM SAX DTD HTML )
					
! !

!ConfigurationOfXMLParser class methodsFor: 'private' stamp: 'DaleHenrichs 2/7/2010 09:39'!
ensureMetacello
	"Bootstrap Gofer (if necessary), bootstrap ConfigurationOfMetacello (using old Gofer API), then load the latest 
	version of Metacello itself."

	Smalltalk at: #MetacelloProject ifAbsent: [
		Smalltalk at: #Gofer ifAbsent: [
			"Current version of Gofer from which to bootstrap - as of 1.0-beta.21"
			self bootstrapPackage: 'Gofer-Core-lr.115' from: 'http://seaside.gemstone.com/ss/metacello' ].
		Smalltalk at: #Gofer ifPresent: [:goferClass | | gofer |
			gofer := goferClass new
				url: 'http://seaside.gemstone.com/ss/metacello';
				yourself.
			[ gofer addPackage: 'ConfigurationOfMetacello' ] on: Warning do: [:ex | ex resume ].
			gofer load ].
		"load 'default' group of Metacello"
		(Smalltalk at: #ConfigurationOfMetacello) perform: #load ]! !

!ConfigurationOfXMLParser class methodsFor: 'metacello tool support' stamp: 'DaleHenrichs 2/7/2010 09:39'!
isMetacelloConfig
	"Answer true and the Metacello tools will operate on you"
	
	^true! !

!ConfigurationOfXMLParser class methodsFor: 'metacello tool support' stamp: 'DaleHenrichs 2/7/2010 09:39'!
lastMetacelloVersionLoad
	"Answer the last version loaded and the list of packages loaded for that version."

	LastVersionLoad == nil ifTrue: [ LastVersionLoad := nil -> 'default' ].
	^LastVersionLoad! !

!ConfigurationOfXMLParser class methodsFor: 'loading' stamp: 'JAAyer 11/20/2010 08:31'!
load
	"self load"

	^self project latestVersion load! !

!ConfigurationOfXMLParser class methodsFor: 'loading' stamp: 'JAAyer 11/20/2010 08:32'!
loadDefault
	"self loadDefault"

	^ self loadMostRecentCoreWithTests! !

!ConfigurationOfXMLParser class methodsFor: 'loading' stamp: 'JAAyer 11/20/2010 08:32'!
loadMostRecentCoreWithTests
	^self project lastVersion load: #('Core' 'Tests')! !

!ConfigurationOfXMLParser class methodsFor: 'metacello tool support' stamp: 'DaleHenrichs 2/7/2010 09:39'!
metacelloVersion: versionString loads: anArrayOrString
	"Stash the last version loaded and the list of packages loaded for that version. The list
	 of packages will be used by the tools when doing 'Load Package Version'"

	LastVersionLoad := versionString -> anArrayOrString! !

!ConfigurationOfXMLParser class methodsFor: 'accessing' stamp: 'DaleHenrichs 2/7/2010 09:39'!
project

	^self new project! !

!ConfigurationOfXMLParser class methodsFor: 'unloading Metacello' stamp: 'DaleHenrichs 2/7/2010 09:39'!
unloadMetacello

	Smalltalk at: #ConfigurationOfMetacello ifPresent: [:cls | cls unloadMetacello ]! !

!ConfigurationOfXMLParser methodsFor: 'baselines' stamp: 'DamienCassou 4/30/2013 18:03'!
baseline10: spec
	<version: '1.0-baseline'>
	spec
		for: #common
		do: [ 
			spec
				blessing: #baseline;
				description: 'Migrated to SmalltalkHub';
				author: 'StephaneDucasse';
				timestamp: '04/30/2013';
				repository: 'http://www.smalltalkhub.com/mc/PharoExtras/XMLParser/main'.

			spec project: 'XMLWriter'
					with: [ spec 
								className: 'ConfigurationOfXMLWriter';
								versionString: #stable;
								repository: 'http://www.smalltalkhub.com/mc/PharoExtras/XMLWriter/main'.].

			spec project: 'BitmapCharacterSet'
					with: [ spec 
								className: 'ConfigurationOfBitmapCharacterSet';
								versionString: #stable;
								repository: 'http://www.smalltalkhub.com/mc/PharoExtras/BitmapCharacterSet/main'.].

		spec project: 'OrderPreservingDictionary' with: [
			spec 
				className: 'ConfigurationOfOrderPreservingDictionary';
				versionString: #stable; 
				loads: #('Core'); 
				repository: 'http://smalltalkhub.com/mc/PharoExtras/OrderPreservingDictionary/main'].	

			spec 
				package: 'XML-Parser' 
				with: [spec 
						requires: #('BitmapCharacterSet' 'OrderPreservingDictionary')].	
			spec package: 'XML-Tests-Parser'
					with: [ spec requires: #('XML-Parser' 'XMLWriter') ].
			
			spec
				group: 'default' with: #('Core' 'Tests');
				"default by default is equivalent to loading 'ALL' the packages still we added explicitly Tests to be loaded"
				group: 'Core' with: #('XML-Parser');
				group: 'Tests' with: #('XML-Tests-Parser') ].
! !

!ConfigurationOfXMLParser methodsFor: 'symbolic versions' stamp: 'StephaneDucasse 11/24/2013 18:30'!
development: spec
	<symbolicVersion: #'development'>

	spec for: #'common' version: '1.3'.
	! !

!ConfigurationOfXMLParser methodsFor: 'accessing' stamp: 'DaleHenrichs 2/7/2010 09:39'!
project

	^ project ifNil: [ | constructor |
		"Bootstrap Metacello if it is not already loaded"
		self class ensureMetacello.
		"Construct Metacello project"
		constructor := (Smalltalk at: #MetacelloVersionConstructor) on: self.
		project := constructor project.
		project loadType: #linear. "change to #atomic if desired"
		project ]! !

!ConfigurationOfXMLParser methodsFor: 'symbolic versions' stamp: 'StephaneDucasse 11/24/2013 18:07'!
stable: spec
	<symbolicVersion: #'stable'>

	spec for: #'common' version: '1.3'.
	! !

!ConfigurationOfXMLParser methodsFor: 'versions' stamp: 'StephaneDucasse 3/2/2013 21:09'!
version100: spec
	<version: '1.0' imports: #('1.0-baseline')>
	spec
		for: #common
		do: [ 
			spec blessing: #release.
			spec
				package: 'XML-Parser' with: 'XML-Parser-NorbertHartl.141';
				package: 'XML-Tests-Parser' with: 'XML-Tests-Parser-JAA.14' 
				].
	
	! !

!ConfigurationOfXMLParser methodsFor: 'versions' stamp: 'SD 3/3/2013 10:45'!
version101: spec
	<version: '1.1' imports: #('1.0-baseline')>
	spec
		for: #common
		do: [ 
			spec blessing: #release.
			spec
				package: 'XML-Parser' with: 'XML-Parser-StephaneDucasse.142';
				package: 'XML-Tests-Parser' with: 'XML-Tests-Parser-StephaneDucasse.15' 
				].
	
	! !

!ConfigurationOfXMLParser methodsFor: 'versions' stamp: 'DamienCassou 4/30/2013 17:53'!
version102: spec
	<version: '1.2' imports: #('1.0-baseline')>
	spec
		for: #common
		do: [ 
			spec blessing: #release.
			spec
				package: 'XML-Parser' with: 'XML-Parser-DamienCassou.143';
				package: 'XML-Tests-Parser' with: 'XML-Tests-Parser-StephaneDucasse.15' 
				].
	
	! !

!ConfigurationOfXMLParser methodsFor: 'versions' stamp: 'StephaneDucasse 11/24/2013 18:31'!
version130: spec
	<version: '1.3' imports: #('1.0-baseline')>
	spec
		for: #common
		do: [ 
			spec blessing: #release.
			spec description: 'Enhancements made by Monty. These updates add validation against internal and external DTDs, proper replacement of general and parameter entites, customizable resolution of external parsed entities using Zinc and FileSystem, awareness of notations and unparsed entities, preservation of the internal DTD subset by the DOM parser (so printing a parsed doc with a DTD will produce approximately what was input), line numbers reporting in error messages, and better well-formed and validity constraints.

I had to largely rewrite the tokenizer to make everything work, but I followed the spec closely, and it is about the same speed as long as there is no DTD to validate against.'.
			spec
				package: 'XML-Parser' with: 'XML-Parser-monty.184';
				package: 'XML-Tests-Parser' with: 'XML-Tests-Parser-monty.28' 
				].
	
	! !
